/*
 * @Description:
 * @Author: leizhe
 * @Date: 2022-01-13 10:47:32
 * @LastEditTime: 2022-06-10 15:13:28
 * @LastEditors: leizhe
 */
/* eslint-disable indent */
import { Button, Spin, Empty } from 'antd';
import React, { useState, useEffect } from 'react';
import styles from '../SchemeConfig.less';
import { GetMaplayerByTerminalType, GettMaplayer } from '@/services/webConfig/api';
import AddModal from './AddModal';
import Cards from './components/card';
const VectorData = props => {
  const [treeLoading, setTreeLoading] = useState(false); // 弹窗显示
  const [tileData, setTileData] = useState([]); // 页面初始化数据
  const [visible, setVisible] = useState(false); // 弹窗
  const [flag, setFlag] = useState(0); // 状态更新
  const [cardFlag, setCardFlag] = useState(false); // 状态更新
  const [type, setType] = useState(''); // 弹窗类型
  const [formObj, setFormObj] = useState({});
  const [keepData, setKeepData] = useState([]);

  const onSubmit = prop => {
    setVisible(false);
    setFlag(flag + 1);
  };
  const onDeletebaseMap = value => {
    setCardFlag(false);
    setFlag(flag + 1);
  };
  const handleAdd = () => {
    setType('schemeAdd');
    setVisible(true);
  };
  useEffect(() => {
    console.log(1212);
    renderTile();
  }, [flag]);

  // 获取瓦片数据配置数据
  const renderTile = () => {
    setTreeLoading(true);
    GetMaplayerByTerminalType({
      terminalType: 'scheme',
      isBaseMap: false,
    }).then(resdata => {
      if (resdata.msg === 'Ok') {
        setTreeLoading(false);
        GettMaplayer({ terminalType: 'base', isBaseMap: true }).then(res => {
          if (res.msg === 'Ok') {
            resdata.data.scheme.optionalLayer.layers.map((j, index) => {
              let arr = [];
              res.data.general.baseMap.layers.map(i => {
                console.log(i);
                arr.push(i.servicename);
              });
              console.log(arr);
              setKeepData(arr);
              let data = [];
              let aa = [];
              j.baseMap.map(k => {
                if (arr.indexOf(k) != -1) {
                  data.push(k);
                } else {
                  aa.push(k);
                }
              });
              let bb = aa.concat(data);
              let i = bb.indexOf(j.baseMap[j.defaultBaseMap]);
              resdata.data.scheme.optionalLayer.layers[index].defaultOldBaseMap = j.baseMap;
              resdata.data.scheme.optionalLayer.layers[index].baseMap = bb;
              resdata.data.scheme.optionalLayer.layers[index].defaultBaseMap = i;
            });
            setTileData(resdata.data.scheme.optionalLayer.layers);
          }
        });
      } else {
        setTreeLoading(false);
      }
    });
  };
  useEffect(() => {
    setCardFlag(true);
  }, [tileData]);
  return (
    <>
      <div className={styles.tileBtn}>
        <Button
          type="primary"
          onClick={() => {
            handleAdd();
          }}
        >
          新增
        </Button>
      </div>
      <Spin tip="loading..." spinning={treeLoading}>
        <div style={{ height: 'calc(100vh - 216px)', width: '100%' }}>
          <div className={styles.cardsList}>
            {/* {console.log(tileData)} */}
            {tileData && tileData.length ? (
              tileData.map((item, index) => {
                return (
                  <div
                    className={styles.cardItem}
                    key={index}
                    span={5}
                    offset={2}
                    style={{ marginBottom: '1rem' }}
                  >
                    <Cards
                      item={item}
                      cardFlag={cardFlag}
                      deletebaseMaps={onDeletebaseMap}
                      keepData={keepData}
                    />
                  </div>
                );
              })
            ) : (
              <Empty image={Empty.PRESENTED_IMAGE_SIMPLE} style={{ margin: 'auto' }} />
            )}
          </div>
          <AddModal
            visible={visible}
            onCancel={() => setVisible(false)}
            callBackSubmit={onSubmit}
            type={type}
            formObj={formObj}
            keepData={keepData}
          />
        </div>
      </Spin>
    </>
  );
};
export default VectorData;
